# Compute rigid and similarity transformations between point sets

# For rigid transformations, we use:
# Kabsch, Wolfgang. "A discussion of the solution for the best rotation to
# relate two sets of vectors." Acta Crystallographica Section A: Crystal
# Physics, Diffraction, Theoretical and General Crystallography 34.5 (1978):
# 827-828.
# This has been generalized to support weighted points:
# https://igl.ethz.ch/projects/ARAP/svd_rot.pdf
# We add the component for similarity transformations from:
# Umeyama, Shinji. "Least-squares estimation of transformation parameters
# between two point patterns." IEEE Transactions on Pattern Analysis & Machine
# Intelligence 13.04 (1991): 376-380.

# See also
# https://en.wikipedia.org/wiki/Kabsch_algorithm


# All matrices are DxN, where N is the number of positions and D is the dimensionality

# Here, P is the probe (to be rotated) and Q is the refereence

# `kabsch_centered` assumes P and Q are already centered at the origin
# returns the rotation (optionally with scaling) for alignment
function kabsch_centered(P, Q, w; scale::Bool=false, svd::F = LinearAlgebra.svd) where F
    @assert size(P) == size(Q)
    W = Diagonal(w/sum(w))
    H = P*W*Q'
    U,Σ,V = svd(H)
    Ddiag = ones(eltype(H), size(H,1))
    Ddiag[end] = sign(det(V*U'))
    c = scale ? sum(Σ .* Ddiag) / sum(P .* (P*W)) : 1
    return LinearMap(V * Diagonal(c * Ddiag) * U')
end

"""
    kabsch(from_points => to_points, w=ones(npoints); scale::Bool=false, svd=LinearAlgebra.svd) → trans

Compute the rigid transformation (or similarity transformation, if `scale=true`)
that aligns `from_points` to `to_points` in a least-squares sense.

Optionally specify the non-negative weights `w` for each point. The default value of the weight
is 1 for each point.

For
differentiability, use `svd = GenericLinearAlgebra.svd` or other differentiable
singular value decomposition.
"""
function kabsch(pr::Pair{<:AbstractMatrix, <:AbstractMatrix}, w::AbstractVector=ones(size(pr.first,2)); scale::Bool=false, kwargs...)
    P, Q = pr
    any(<(0), w) && throw(ArgumentError("weights must be non-negative"))
    all(iszero, w) && throw(ArgumentError("weights must not all be zero"))
    wn = w/sum(w)
    centerP, centerQ = P*wn, Q*wn
    R = kabsch_centered(P .- centerP, Q .- centerQ, w; scale, kwargs...)
    return inv(Translation(-centerQ)) ∘ R ∘ Translation(-centerP)
end
kabsch((from_points, to_points)::Pair, args...; kwargs...) = kabsch(column_matrix(from_points) => column_matrix(to_points), args...; kwargs...)

#############################
### 2D Coordinate systems ###
#############################
"""
    Polar{T,A}(r::T, θ::A)

2D polar coordinates
"""
struct Polar{T,A}
    r::T
    θ::A

    Polar{T, A}(r, θ) where {T, A} = new(r, θ)
end

function Polar(r, θ)
    r2, θ2 = promote(r, θ)

    return Polar{typeof(r2), typeof(θ2)}(r2, θ2)
end

"""
    Polar{T,T}(x::AbstractVector)

2D polar coordinates from an AbstractVector of length 2
"""
function Polar(x::AbstractVector)
    return PolarFromCartesian()(x)
end

Base.show(io::IO, x::Polar) = print(io, "Polar(r=$(x.r), θ=$(x.θ) rad)")
Base.isapprox(p1::Polar, p2::Polar; kwargs...) = isapprox(p1.r, p2.r; kwargs...) && isapprox(p1.θ, p2.θ; kwargs...)

"""
    PolarFromCartesian()

Transformation from `AbstractVector` of length 2 to `Polar` type
"""
struct PolarFromCartesian <: Transformation; end
"""
    CartesianFromPolar()

Transformation from `Polar` type to `SVector{2}` type
"""
struct CartesianFromPolar <: Transformation; end

Base.show(io::IO, trans::PolarFromCartesian) = print(io, "PolarFromCartesian()")
Base.show(io::IO, trans::CartesianFromPolar) = print(io, "CartesianFromPolar()")

function (::PolarFromCartesian)(x::AbstractVector)
    length(x) == 2 || error("Polar transform takes a 2D coordinate")

    Polar(hypot(x[1], x[2]), atan(x[2], x[1]))
end

function transform_deriv(::PolarFromCartesian, x::AbstractVector)
    length(x) == 2 || error("Polar transform takes a 2D coordinate")

    r = hypot(x[1], x[2])
    f = x[2] / x[1]
    c = one(eltype(x))/(x[1]*(one(eltype(x)) + f*f))
    @SMatrix [ x[1]/r    x[2]/r ;
              -f*c       c      ]
end
transform_deriv_params(::PolarFromCartesian, x::AbstractVector) = error("PolarFromCartesian has no parameters")

function (::CartesianFromPolar)(x::Polar)
    s,c = sincos(x.θ)
    SVector(x.r * c, x.r * s)
end
function transform_deriv(::CartesianFromPolar, x::Polar)
    sθ, cθ = sincos(x.θ)
    @SMatrix [cθ  -x.r*sθ ;
              sθ   x.r*cθ ]
end
transform_deriv_params(::CartesianFromPolar, x::Polar) = error("CartesianFromPolar has no parameters")

Base.inv(::PolarFromCartesian) = CartesianFromPolar()
Base.inv(::CartesianFromPolar) = PolarFromCartesian()

compose(::PolarFromCartesian, ::CartesianFromPolar) = IdentityTransformation()
compose(::CartesianFromPolar, ::PolarFromCartesian) = IdentityTransformation()

# For convenience
Base.convert(::Type{Polar}, v::AbstractVector) = PolarFromCartesian()(v)
@inline Base.convert(::Type{V}, p::Polar) where {V <: AbstractVector} = convert(V, CartesianFromPolar()(p))
@inline Base.convert(::Type{V}, p::Polar) where {V <: StaticVector} = convert(V, CartesianFromPolar()(p))


#############################
### 3D Coordinate Systems ###
#############################
"""
    Spherical(r, θ, ϕ)

3D spherical coordinates

There are many Spherical coordinate conventions and this library uses a somewhat exotic one.
Given a vector `v` with Cartesian coordinates `xyz`, let `v_xy = [x,y,0]` be the
orthogonal projection of `v` on the `xy` plane.

* `r` is the radius. It is given by `norm(v, 2)`.
* `θ` is the azimuth. It is the angle from the x-axis to `v_xy`
* `ϕ` is the latitude. It is the angle from `v_xy` to `v`.

```jldoctest
julia> v = randn(3);

julia> sph = SphericalFromCartesian()(v);

julia> r = sph.r; θ = sph.θ; ϕ = sph.ϕ;

julia> v ≈ [r * cos(θ) * cos(ϕ), r * sin(θ) * cos(ϕ), r * sin(ϕ)]
true
```
"""
struct Spherical{T,A}
    r::T
    θ::A
    ϕ::A

    Spherical{T, A}(r, θ, ϕ) where {T, A} = new(r, θ, ϕ)
end

function Spherical(r, θ, ϕ)
    r2, θ2, ϕ2 = promote(r, θ, ϕ)

    return Spherical{typeof(r2), typeof(θ2)}(r2, θ2, ϕ2)
end

Base.show(io::IO, x::Spherical) = print(io, "Spherical(r=$(x.r), θ=$(x.θ) rad, ϕ=$(x.ϕ) rad)")
Base.isapprox(p1::Spherical, p2::Spherical; kwargs...) =
    isapprox(p1.r, p2.r; kwargs...) && isapprox(p1.θ, p2.θ; kwargs...) && isapprox(p1.ϕ, p2.ϕ; kwargs...)

"""
    Cylindrical(r, θ, z)

3D cylindrical coordinates
"""
struct Cylindrical{T,A}
    r::T
    θ::A
    z::T

    Cylindrical{T, A}(r, θ, z) where {T, A} = new(r, θ, z)
end

function Cylindrical(r, θ, z)
    r2, θ2, z2 = promote(r, θ, z)

    return Cylindrical{typeof(r2), typeof(θ2)}(r2, θ2, z2)
end

Base.show(io::IO, x::Cylindrical) = print(io, "Cylindrical(r=$(x.r), θ=$(x.θ) rad, z=$(x.z))")
Base.isapprox(p1::Cylindrical, p2::Cylindrical; kwargs...) =
    isapprox(p1.r, p2.r; kwargs...) && isapprox(p1.θ, p2.θ; kwargs...) && isapprox(p1.z, p2.z; kwargs...)

"""
    SphericalFromCartesian()

Transformation from 3D point to `Spherical` type
"""
struct SphericalFromCartesian <: Transformation; end
"""
    CartesianFromSpherical()

Transformation from `Spherical` type to `SVector{3}` type
"""
struct CartesianFromSpherical <: Transformation; end
"""
    CylindricalFromCartesian()

Transformation from 3D point to `Cylindrical` type
"""
struct CylindricalFromCartesian <: Transformation; end
"""
    CartesianFromCylindrical()

Transformation from `Cylindrical` type to `SVector{3}` type
"""
struct CartesianFromCylindrical <: Transformation; end
"""
    CylindricalFromSpherical()

Transformation from `Spherical` type to `Cylindrical` type
"""
struct CylindricalFromSpherical <: Transformation; end
"""
    SphericalFromCylindrical()

Transformation from `Cylindrical` type to `Spherical` type
"""
struct SphericalFromCylindrical <: Transformation; end

Base.show(io::IO, trans::SphericalFromCartesian) = print(io, "SphericalFromCartesian()")
Base.show(io::IO, trans::CartesianFromSpherical) = print(io, "CartesianFromSpherical()")
Base.show(io::IO, trans::CylindricalFromCartesian) = print(io, "CylindricalFromCartesian()")
Base.show(io::IO, trans::CartesianFromCylindrical) = print(io, "CartesianFromCylindrical()")
Base.show(io::IO, trans::CylindricalFromSpherical) = print(io, "CylindricalFromSpherical()")
Base.show(io::IO, trans::SphericalFromCylindrical) = print(io, "SphericalFromCylindrical()")

# Cartesian <-> Spherical
function (::SphericalFromCartesian)(x::AbstractVector)
    length(x) == 3 || error("Spherical transform takes a 3D coordinate")

    Spherical(hypot(x[1], x[2], x[3]), atan(x[2], x[1]), atan(x[3], hypot(x[1], x[2])))
end
function transform_deriv(::SphericalFromCartesian, x::AbstractVector)
    length(x) == 3 || error("Spherical transform takes a 3D coordinate")
    T = eltype(x)

    r = hypot(x[1], x[2], x[3])
    rxy = hypot(x[1], x[2])
    fxy = x[2] / x[1]
    cxy = one(T)/(x[1]*(one(T) + fxy*fxy))
    f = -x[3]/(rxy*r*r)

    @SMatrix [ x[1]/r   x[2]/r  x[3]/r;
          -fxy*cxy  cxy     zero(T);
           f*x[1]   f*x[2]  rxy/(r*r) ]
end
transform_deriv_params(::SphericalFromCartesian, x::AbstractVector) =
    error("SphericalFromCartesian has no parameters")

function (::CartesianFromSpherical)(x::Spherical)
    sθ, cθ = sincos(x.θ)
    sϕ, cϕ = sincos(x.ϕ)
    SVector(x.r * cθ * cϕ, x.r * sθ * cϕ, x.r * sϕ)
end
function transform_deriv(::CartesianFromSpherical, x::Spherical{T}) where T
    sθ, cθ = sincos(x.θ)
    sϕ, cϕ = sincos(x.ϕ)
    @SMatrix [cθ*cϕ -x.r*sθ*cϕ -x.r*cθ*sϕ ;
              sθ*cϕ  x.r*cθ*cϕ -x.r*sθ*sϕ ;
              sϕ     zero(T)    x.r * cϕ  ]
end
transform_deriv_params(::CartesianFromSpherical, x::Spherical) =
    error("CartesianFromSpherical has no parameters")

# Cartesian <-> Cylindrical
function (::CylindricalFromCartesian)(x::AbstractVector)
    length(x) == 3 || error("Cylindrical transform takes a 3D coordinate")

    Cylindrical(hypot(x[1], x[2]), atan(x[2], x[1]), x[3])
end

function transform_deriv(::CylindricalFromCartesian, x::AbstractVector)
    length(x) == 3 || error("Cylindrical transform takes a 3D coordinate")
    T = eltype(x)

    r = hypot(x[1], x[2])
    f = x[2] / x[1]
    c = one(T)/(x[1]*(one(T) + f*f))
    @SMatrix [ x[1]/r   x[2]/r   zero(T) ;
              -f*c      c        zero(T) ;
               zero(T)  zero(T)  one(T)  ]
end
transform_deriv_params(::CylindricalFromCartesian, x::AbstractVector) =
    error("CylindricalFromCartesian has no parameters")

function (::CartesianFromCylindrical)(x::Cylindrical)
    sθ, cθ = sincos(x.θ)
    SVector(x.r * cθ, x.r * sθ, x.z)
end
function transform_deriv(::CartesianFromCylindrical, x::Cylindrical{T}) where {T}
    sθ, cθ = sincos(x.θ)
    @SMatrix [cθ      -x.r*sθ  zero(T) ;
              sθ       x.r*cθ  zero(T) ;
              zero(T)  zero(T) one(T)  ]
end
transform_deriv_params(::CartesianFromPolar, x::Cylindrical) =
    error("CartesianFromCylindrical has no parameters")

function (::CylindricalFromSpherical)(x::Spherical)
    sϕ, cϕ = sincos(x.ϕ)
    Cylindrical(x.r*cϕ,x.θ,x.r*sϕ)
end
function transform_deriv(::CylindricalFromSpherical, x::Spherical)
    M1 = transform_deriv(CylindricalFromCartesian(), CartesianFromSpherical()(x))
    M2 = transform_deriv(CartesianFromSpherical(), x)
    return M1*M2
end
transform_deriv_params(::CylindricalFromSpherical, x::Spherical) =
    error("CylindricalFromSpherical has no parameters")

function (::SphericalFromCylindrical)(x::Cylindrical)
    Spherical(hypot(x.r,x.z),x.θ,atan(x.z,x.r))
end
function transform_deriv(::SphericalFromCylindrical, x::Cylindrical)
    M1 = transform_deriv(SphericalFromCartesian(), CartesianFromCylindrical()(x))
    M2 = transform_deriv(CartesianFromCylindrical(), x)
    return M1*M2
end
transform_deriv_params(::SphericalFromCylindrical, x::Cylindrical) =
    error("SphericalFromCylindrical has no parameters")

Base.inv(::SphericalFromCartesian)   = CartesianFromSpherical()
Base.inv(::CartesianFromSpherical)   = SphericalFromCartesian()
Base.inv(::CylindricalFromCartesian) = CartesianFromCylindrical()
Base.inv(::CartesianFromCylindrical) = CylindricalFromCartesian()
Base.inv(::CylindricalFromSpherical) = SphericalFromCylindrical()
Base.inv(::SphericalFromCylindrical) = CylindricalFromSpherical()

# Inverse composition
compose(::SphericalFromCartesian,   ::CartesianFromSpherical)   = IdentityTransformation()
compose(::CartesianFromSpherical,   ::SphericalFromCartesian)   = IdentityTransformation()
compose(::CylindricalFromCartesian, ::CartesianFromCylindrical) = IdentityTransformation()
compose(::CartesianFromCylindrical, ::CylindricalFromCartesian) = IdentityTransformation()
compose(::CylindricalFromSpherical, ::SphericalFromCylindrical) = IdentityTransformation()
compose(::SphericalFromCylindrical, ::CylindricalFromSpherical) = IdentityTransformation()

# Cyclic compositions
compose(::SphericalFromCartesian,   ::CartesianFromCylindrical) = SphericalFromCylindrical()
compose(::CartesianFromSpherical,   ::SphericalFromCylindrical) = CartesianFromCylindrical()
compose(::CylindricalFromCartesian, ::CartesianFromSpherical)   = CylindricalFromSpherical()
compose(::CartesianFromCylindrical, ::CylindricalFromSpherical) = CartesianFromSpherical()
compose(::CylindricalFromSpherical, ::SphericalFromCartesian)   = CylindricalFromCartesian()
compose(::SphericalFromCylindrical, ::CylindricalFromCartesian) = SphericalFromCartesian()

# For convenience
Base.convert(::Type{Spherical}, v::AbstractVector) = SphericalFromCartesian()(v)
Base.convert(::Type{Cylindrical}, v::AbstractVector) = CylindricalFromCartesian()(v)

Base.convert(::Type{V}, s::Spherical) where {V <: AbstractVector} = convert(V, CartesianFromSpherical()(s))
Base.convert(::Type{V}, c::Cylindrical) where {V <: AbstractVector} = convert(V, CartesianFromCylindrical()(c))
Base.convert(::Type{V}, s::Spherical) where {V <: StaticVector} = convert(V, CartesianFromSpherical()(s))
Base.convert(::Type{V}, c::Cylindrical) where {V <: StaticVector} = convert(V, CartesianFromCylindrical()(c))

Base.convert(::Type{Spherical}, c::Cylindrical) = SphericalFromCylindrical()(c)
Base.convert(::Type{Cylindrical}, s::Spherical) = CylindricalFromSpherical()(s)

using CoordinateTransformations
using Documenter
using Documenter.Remotes: GitHub

DocMeta.setdocmeta!(
    CoordinateTransformations,
    :DocTestSetup,
    :(using CoordinateTransformations),
    recursive = true,
)

makedocs(
    sitename = "CoordinateTransformations.jl",
    modules = [CoordinateTransformations],
    repo = GitHub("JuliaGeometry/CoordinateTransformations.jl"),
    pages = [
        "Introduction" => "index.md",
        "API" => "api.md",
    ],
)

deploydocs(
    repo = "github.com/JuliaGeometry/CoordinateTransformations.jl.git"
)

#####################################
### Interface for transformations ###
#####################################

# The external interface consists of transform(), Base.inv(),  compose() (or ∘),
# transform_deriv() and transform_deriv_params()

"""
    abstract type Transformation

The `Transformation` supertype defines a simple interface for performing
transformations. Subtypes should be able to apply a coordinate system
transformation on the correct data types by overloading the call method, and
usually would have the corresponding inverse transformation defined by `Base.inv()`.
Efficient compositions can optionally be defined by `compose()` (equivalently `∘`).
"""
abstract type Transformation end

"""
    IdentityTransformation <: Transformation

The `IdentityTransformation` is a singleton `Transformation` that returns the
input unchanged, similar to `identity`.
"""
struct IdentityTransformation <: Transformation; end

@inline (::IdentityTransformation)(x) = x

"""
    ComposedTransformation{T1, T2} <: Transformation

A `ComposedTransformation` simply executes two transformations `T2` and `T1`
successively, and is the fallback output type of `compose()`.
"""
struct ComposedTransformation{T1 <: Transformation, T2 <: Transformation} <: Transformation
    t1::T1
    t2::T2
end

Base.show(io::IO, trans::ComposedTransformation) = print(io, "($(trans.t1) ∘ $(trans.t2))")

@inline function (trans::ComposedTransformation)(x)
    trans.t1(trans.t2(x))
end

function Base.:(==)(trans1::ComposedTransformation, trans2::ComposedTransformation)
    (trans1.t1 == trans2.t1) && (trans1.t2 == trans2.t2)
end

function Base.isapprox(trans1::ComposedTransformation, trans2::ComposedTransformation; kwargs...)
    isapprox(trans1.t1, trans2.t1; kwargs...) && isapprox(trans1.t2, trans2.t2; kwargs...)
end

const compose = ∘

"""
    compose(trans1, trans2)
    trans1 ∘ trans2

Take two transformations and create a new transformation that is equivalent to
successively applying `trans2` to the coordinate, and then `trans1`. By default
will create a `ComposedTransformation`, however this method can be overloaded
for efficiency (e.g. two affine transformations naturally compose to a single
affine transformation).
"""
function compose(trans1::Transformation, trans2::Transformation)
    ComposedTransformation(trans1, trans2)
end

compose(trans::IdentityTransformation, ::IdentityTransformation) = trans
compose(::IdentityTransformation, trans::Transformation) = trans
compose(trans::Transformation, ::IdentityTransformation) = trans


"""
    inv(trans::Transformation)

Returns the inverse (or reverse) of the transformation `trans`
"""
function Base.inv(trans::Transformation)
    error("Inverse transformation for $(typeof(trans)) has not been defined.")
end

Base.inv(trans::ComposedTransformation) = inv(trans.t2) ∘ inv(trans.t1)
Base.inv(trans::IdentityTransformation) = trans

"""
    recenter(trans::Union{AbstractMatrix,Transformation}, origin::Union{AbstractVector, Tuple}) -> ctrans

Return a new transformation `ctrans` such that point `origin` serves
as the origin-of-coordinates for `trans`. Translation by `±origin`
occurs both before and after applying `trans`, so that if `trans` is
linear we have

    ctrans(origin) == origin

As a consequence, `recenter` only makes sense if the output space of
`trans` is isomorphic with the input space.

For example, if `trans` is a rotation matrix, then `ctrans` rotates
space around `origin`.
"""
function recenter(trans::Transformation, origin::AbstractVector)
    Translation(origin) ∘ trans ∘ Translation(-origin)
end
recenter(trans::Transformation, origin::Tuple) = recenter(trans, SVector(origin))


"""
    transform_deriv(trans::Transformation, x)

A matrix describing how differentials on the parameters of `x` flow through to
the output of transformation `trans`.
"""
transform_deriv(trans::Transformation, x) =
    error("Differential matrix of transform $trans with input $x not defined")

transform_deriv(::IdentityTransformation, x) = I

function transform_deriv(trans::ComposedTransformation, x)
    x2 = trans.t2(x)
    m1 = transform_deriv(trans.t1, x2)
    m2 = transform_deriv(trans.t2, x)
    return m1 * m2
end


"""
    transform_deriv_params(trans::Transformation, x)

A matrix describing how differentials on the parameters of `trans` flow through
to the output of transformation `trans` given input `x`.
"""
transform_deriv_params(trans::Transformation, x) =
    error("Differential matrix of parameters of transform $trans with input $x not defined")

transform_deriv_params(::IdentityTransformation, x) =
    error("IdentityTransformation has no parameters")

function transform_deriv_params(trans::ComposedTransformation, x)
    x2 = trans.t2(x)
    m1 = transform_deriv(trans.t1, x2)
    p2 = transform_deriv_params(trans.t2, x)
    p1 = transform_deriv_params(trans.t1, x2)
    return hcat(p1, m1*p2)
end

# A transformation for testing the local affine mapping
struct SquareMe <: Transformation; end
(::SquareMe)(x) = x.^2
CoordinateTransformations.transform_deriv(::SquareMe, x0) = Matrix(Diagonal(2*x0))

struct Ray37
    origin::Vector
    direction::Vector
end
function (m::LinearMap)(r::Ray37)
    Ray37(m(r.origin),
          m(r.direction))
end
function (t::Translation)(r::Ray37)
    Ray37(t(r.origin),
          r.direction)
end

@testset "Common Transformations" begin
    @testset "AffineMap" begin
        @testset "Simple" begin
            M = [1 2; 3 4]
            v = [-1, 1]
            x = [1,0]
            y = [0.0,1.0]
            A = AffineMap(M,v)
            @test A(x) == M*x + v
        end

        @testset "composition " begin
            M1 = [1 2; 3 4]
            v1 = [-1, 1]
            A1 = AffineMap(M1,v1)
            M2 = [0 1; 1 0]
            v2 = [-2, 0]
            A2 = AffineMap(M2,v2)
            x = [1,0]
            y = [0,1]
            @test A1(x) == M1*x + v1
            @test A1(y) == M1*y + v1
            @test (A2∘A1)(x) == M2*(M1*x + v1) + v2
            @test (A2∘A1)(y) == M2*(M1*y + v1) + v2
        end

        @testset "inverse" begin
            M = [1.0 2.0; 3.0 4.0]
            v = [-1.0, 1.0]
            x = [1,0]
            y = [0.0,1.0]
            A = AffineMap(M,v)
            @test inv(A)(A(x)) ≈ x
            @test inv(A)(A(y)) ≈ y
        end

        @testset "Affine approximation" begin
            S = SquareMe()
            x0 = [1,2,3]
            dx = 0.1*[1,-1,1]
            A = AffineMap(S, x0)
            @test isapprox(S(x0 + dx), A(x0 + dx), atol=maximum(2*dx.^2))
        end
    end

    @testset "LinearMap" begin
        M = [1 2; 3 4]
        x = [1,0]
        y = [0,1]
        L = LinearMap(M)
        @test L(x) == M*x
        @test inv(L)(x) == inv(M)*x
        @test inv(L)(y) == inv(M)*y
        @test inv(L)(L(x)) ≈ x
        @test inv(L)(L(y)) ≈ y
        @test (L∘L)(x) == (M*M)*x
        @test L == AffineMap(M, [0, 0])
    end

    @testset "Translation" begin
        x = SVector(1.0, 2.0)
        trans = Translation(2.0, -1.0)
        @test trans == AffineMap([1 0; 0 1], [2.0, -1.0])

        # Inverse
        @test inv(trans) == Translation(-2.0, 1.0)

        # Composition
        @test trans ∘ trans == Translation(4.0, -2.0)

        # Transform
        @test trans(x) === SVector(3.0, 1.0)
        @test trans(collect(x)) == [3.0, 1.0]

        # Transform derivative
        m1 = transform_deriv(trans, x)
        m2 = [m1[i,j] for i=1:2, j=1:2] # m1 might be a UniformScaling
        @test m2 == Matrix(I, 2, 2)  # in v0.7 and above, this can just be `== I`

        # Transform parameter derivative
        m1 = transform_deriv_params(trans, x)
        m2 = [m1[i,j] for i=1:2, j=1:2] # m1 might be a UniformScaling
        @test m2 == Matrix(I, 2, 2)  # In v0.7 and above, this can just be `== I`
    end

    @testset "Recenter" begin
        M = [1 2; 3 4]
        for origin in ([5,-3], @SVector([5,-3]))
            c = recenter(M, origin)
            @test c(origin) == origin
            @test c(zero(origin)) == [6,-6]
        end

        # Tuple is converted to SVector first
        origin = (5, -3)
        new_origin = SVector(origin)
        c = recenter(M, origin)
        @test c(origin) == new_origin
        @test c(zero(new_origin)) == [6, -6]
    end

    @testset "application of AffineMap in terms of LinearMap and Translation" begin
        origin = randn(3)
        direction = randn(3)
        linear = randn(3,3)
        trans = randn(3)
        r = Ray37(origin, direction)
        expected = Ray37(linear*origin+trans, linear*direction)
        result   = AffineMap(linear, trans)(r)
        @test expected.origin ≈ result.origin
        @test expected.direction ≈ result.direction
    end

    @testset "construction from points" begin
        M = [1.0 2.0; 3.0 4.0]
        v = [-1.0, 1.0]
        A = AffineMap(M,v)
        from_points = [[0.0, 0.0], [1.0, 0.0], [0.0, 1.0], [1.0, 1.0]]
        to_points = map(A, from_points)
        A2 = AffineMap(from_points => to_points)
        @test A2 ≈ A
        A2 = AffineMap(reduce(hcat, from_points) => reduce(hcat, to_points))
        @test A2 ≈ A
        from_points = ([0.0, 0.0], [1.0, 0.0], [0.0, 1.0], [1.0, 1.0])
        to_points = map(A, from_points)
        A2 = AffineMap(from_points => to_points)
        @test A2 ≈ A

        ## Rigid transformations
        θ = π / 7
        R = [cos(θ) -sin(θ); sin(θ) cos(θ)]
        v = [0.87, 0.15]
        A = AffineMap(R, v)
        from_points = [[0.0, 0.0], [1.0, 0.0], [0.0, 1.0], [1.0, 1.0]]
        to_points = map(A, from_points)
        A2 = @inferred(kabsch(from_points => to_points))
        @test A2 ≈ A
        # with weights
        A2 = kabsch(from_points => to_points, [0.2, 0.7, 0.9, 0.3])
        @test A2 ≈ A
        A2 = kabsch(reduce(hcat, from_points) => reduce(hcat, to_points))
        @test A2 ≈ A
        from_points = ([0.0, 0.0], [1.0, 0.0], [0.0, 1.0], [1.0, 1.0])
        to_points = map(A, from_points)
        A2 = kabsch(from_points => to_points)
        @test A2 ≈ A
        # with user-specified SVD
        A2 = @inferred(kabsch(from_points => to_points; svd=LinearAlgebra.svd))
        @test A2 ≈ A
        # when a rigid transformation is not possible
        A2 = kabsch(from_points => 1.1 .* from_points)
        @test A2.linear' * A2.linear ≈ I

        @test_throws "weights must be non-negative" kabsch(from_points => to_points, [0.2, -0.7, 0.9, 0.3])
        @test_throws "weights must not all be zero" kabsch(from_points => to_points, [0.0, 0.0, 0.0, 0.0])

        # Similarity transformations
        θ = π / 7
        R = [cos(θ) -sin(θ); sin(θ) cos(θ)]
        v = [0.87, 0.15]
        c = 1.15
        A = AffineMap(c * R, v)
        from_points = [[0.0, 0.0], [1.0, 0.0], [0.0, 1.0], [1.0, 1.0]]
        to_points = map(A, from_points)
        A2 = @inferred(kabsch(from_points => to_points; scale=true))
        @test A2 ≈ A
        A2 = @inferred(kabsch(from_points => to_points, [0.2, 0.7, 0.9, 0.3]; scale=true))
        @test A2 ≈ A
    end
end

@testset "Coordinate Systems" begin
    @testset "2D" begin
        c_from_p = CartesianFromPolar()
        p_from_c = PolarFromCartesian()
        identity_c = IdentityTransformation()
        identity_p = IdentityTransformation()

        @test inv(c_from_p) == p_from_c
        @test inv(p_from_c) == c_from_p

        @test p_from_c ∘ c_from_p == identity_p
        @test c_from_p ∘ p_from_c == identity_c

        # test identity
        @test p_from_c ∘ identity_c == p_from_c
        @test identity_p ∘ p_from_c == p_from_c

        # Test all four quadrants of the plane (for consistency of branch-cut)
        # Include derivative tests... compare with automatic differentiation (forward mode from ForwardDiff.Dual)

        # 1st quadrant
        xy = SVector(1.0, 2.0)
        rθ = Polar(2.23606797749979, 1.1071487177940904)
        @test p_from_c(xy) ≈ rθ
        @test p_from_c(collect(xy)) ≈ rθ
        @test c_from_p(rθ) ≈ xy

        # TODO - define some convenience functions to create the gradient numbers and unpack the arrays.
        xy_gn = SVector(Dual(1.0, (1.0,0.0)), Dual(2.0, (0.0,1.0)))
        rθ_gn = p_from_c(xy_gn)
        m_gn = @SMatrix [partials(rθ_gn.r, 1) partials(rθ_gn.r, 2);
                    partials(rθ_gn.θ, 1) partials(rθ_gn.θ, 2) ]
        m = transform_deriv(p_from_c, xy)
        @test m ≈ m_gn

        rθ_gn = Polar(Dual(2.23606797749979, (1.0, 0.0)), Dual(1.1071487177940904, (0.0, 1.0)))
        xy_gn = c_from_p(rθ_gn)
        m_gn = @SMatrix [partials(xy_gn[1], 1) partials(xy_gn[1], 2);
                    partials(xy_gn[2], 1) partials(xy_gn[2], 2) ]
        m = transform_deriv(c_from_p, rθ)
        @test m ≈ m_gn

        # 2nd quadrant
        xy = SVector(-1.0, 2.0)
        rθ = Polar(2.23606797749979, 2.0344439357957027)
        @test p_from_c(xy) ≈ rθ
        @test c_from_p(rθ) ≈ xy

        xy_gn = SVector(Dual(-1.0, (1.0,0.0)), Dual(2.0, (0.0,1.0)))
        rθ_gn = p_from_c(xy_gn)
        m_gn = @SMatrix [partials(rθ_gn.r, 1) partials(rθ_gn.r, 2);
                    partials(rθ_gn.θ, 1) partials(rθ_gn.θ, 2) ]
        m = transform_deriv(p_from_c, xy)
        @test m ≈ m_gn

        rθ_gn = Polar(Dual(2.23606797749979, (1.0, 0.0)), Dual(2.0344439357957027, (0.0, 1.0)))
        xy_gn = c_from_p(rθ_gn)
        m_gn = @SMatrix [partials(xy_gn[1], 1) partials(xy_gn[1], 2);
                    partials(xy_gn[2], 1) partials(xy_gn[2], 2) ]
        m = transform_deriv(c_from_p, rθ)
        @test m ≈ m_gn

        # 3rd quadrant
        xy = SVector(1.0, -2.0)
        rθ = Polar(2.23606797749979, -1.1071487177940904)
        @test p_from_c(xy) ≈ rθ
        @test c_from_p(rθ) ≈ xy

        xy_gn = SVector(Dual(1.0, (1.0,0.0)), Dual(-2.0, (0.0,1.0)))
        rθ_gn = p_from_c(xy_gn)
        m_gn = @SMatrix [partials(rθ_gn.r, 1) partials(rθ_gn.r, 2);
                    partials(rθ_gn.θ, 1) partials(rθ_gn.θ, 2) ]
        m = transform_deriv(p_from_c, xy)
        @test m ≈ m_gn

        rθ_gn = Polar(Dual(2.23606797749979, (1.0, 0.0)), Dual(-1.1071487177940904, (0.0, 1.0)))
        xy_gn = c_from_p(rθ_gn)
        m_gn = @SMatrix [partials(xy_gn[1], 1) partials(xy_gn[1], 2);
                    partials(xy_gn[2], 1) partials(xy_gn[2], 2) ]
        m = transform_deriv(c_from_p, rθ)
        @test m ≈ m_gn

        # 4th quadrant
        xy = SVector(-1.0, -2.0)
        rθ = Polar(2.23606797749979, -2.0344439357957027)
        @test p_from_c(xy) ≈ rθ
        @test c_from_p(rθ) ≈ xy

        xy_gn = SVector(Dual(-1.0, (1.0,0.0)), Dual(-2.0, (0.0,1.0)))
        rθ_gn = p_from_c(xy_gn)
        m_gn = @SMatrix [partials(rθ_gn.r, 1) partials(rθ_gn.r, 2);
                    partials(rθ_gn.θ, 1) partials(rθ_gn.θ, 2) ]
        m = transform_deriv(p_from_c, xy)
        @test m ≈ m_gn

        rθ_gn = Polar(Dual(2.23606797749979, (1.0, 0.0)), Dual(-2.0344439357957027, (0.0, 1.0)))
        xy_gn = c_from_p(rθ_gn)
        m_gn = @SMatrix [partials(xy_gn[1], 1) partials(xy_gn[1], 2);
                    partials(xy_gn[2], 1) partials(xy_gn[2], 2) ]
        m = transform_deriv(c_from_p, rθ)
        @test m ≈ m_gn

        @testset "Common types" begin
            xy = SVector(1.0, 2.0)
            xy_i = SVector(1,2)
            p1 = Polar(1, 2.0f0)
            p2 = Polar(1.0, 2)
            p3 = Polar{Int, Float64}(1, 2.0)
            rθ = Polar(2.23606797749979, 1.1071487177940904)

            @test typeof(p1.r) == typeof(p1.θ)
            @test typeof(p2.r) == typeof(p2.θ)
            @test typeof(p3.r) == Int
            @test typeof(p3.θ) == Float64

            @test p_from_c(xy_i) ≈ rθ
            @test p_from_c(xy) ≈ rθ
            @test p_from_c(collect(xy)) ≈ rθ
            @test c_from_p(rθ) ≈ xy
        end

        @testset "Units" begin
            xy = SVector(1.0, 2.0)u"m"
            rθ = Polar(2.23606797749979u"m", 1.1071487177940904)

            @test p_from_c(xy) ≈ rθ
            @test p_from_c(collect(xy)) ≈ rθ
            @test c_from_p(rθ) ≈ xy
        end

        @testset "Convenience Polar() constructor" begin
            @test typeof(Polar(SVector(1.0,2.0))) == typeof(Polar(1.0, 1.0))
            @test typeof(Polar(SVector(1.0f0,2.0f0))) == typeof(Polar(1.0f0, 1.0f0))
            @test Polar(SVector(0,2)) ≈ Polar(2,π/2)
            @test Polar(SVector(1,1)) ≈ Polar(sqrt(2),π/4)
            @test Polar([1,1]) ≈ Polar(sqrt(2),π/4)
            if Base.VERSION >= v"1.7"
                @test_throws "Polar transform takes a 2D coordinate" Polar([1,1,1])
            else
                @test_throws ErrorException("Polar transform takes a 2D coordinate") Polar([1,1,1])
            end
        end
    end

    @testset "3D" begin
        s_from_cart = SphericalFromCartesian()
        cart_from_s = CartesianFromSpherical()
        cyl_from_cart = CylindricalFromCartesian()
        cart_from_cyl = CartesianFromCylindrical()
        cyl_from_s = CylindricalFromSpherical()
        s_from_cyl = SphericalFromCylindrical()
        identity_cart = IdentityTransformation()
        identity_s = IdentityTransformation()
        identity_cyl = IdentityTransformation()

        # inverses
        @test inv(s_from_cart) == cart_from_s
        @test inv(cart_from_s) == s_from_cart
        @test inv(cyl_from_cart) == cart_from_cyl
        @test inv(cart_from_cyl) == cyl_from_cart
        @test inv(s_from_cyl) == cyl_from_s
        @test inv(cyl_from_s) == s_from_cyl

        # composition of inverses
        @test s_from_cart ∘ cart_from_s == identity_s
        @test cart_from_s ∘ s_from_cart == identity_cart
        @test cyl_from_cart ∘ cart_from_cyl == identity_cyl
        @test cart_from_cyl ∘ cyl_from_cart == identity_cart
        @test s_from_cyl ∘ cyl_from_s == identity_s
        @test cyl_from_s ∘ s_from_cyl == identity_cyl

        # cyclic composition
        @test s_from_cart ∘ cart_from_cyl == s_from_cyl
        @test cart_from_s ∘ s_from_cyl == cart_from_cyl
        @test cyl_from_cart ∘ cart_from_s == cyl_from_s
        @test cart_from_cyl ∘ cyl_from_s == cart_from_s
        @test s_from_cyl ∘ cyl_from_cart == s_from_cart
        @test cyl_from_s ∘ s_from_cart == cyl_from_cart

        # Spherical <-> Cartesian
        # test all 8 octants of the sphere (for consistency of branch-cuts)

        # Octant 1
        xyz = SVector(1.0, 2.0, 3.0)
        rθϕ = Spherical(3.7416573867739413, 1.1071487177940904, 0.9302740141154721)
        @test s_from_cart(xyz) ≈ rθϕ
        @test s_from_cart(collect(xyz)) ≈ rθϕ
        @test cart_from_s(rθϕ) ≈ xyz

        xyz_gn = SVector(Dual(1.0, (1.0, 0.0, 0.0)), Dual(2.0, (0.0, 1.0, 0.0)), Dual(3.0, (0.0, 0.0, 1.0)))
        rθϕ_gn = s_from_cart(xyz_gn)
        m_gn = @SMatrix [partials(rθϕ_gn.r, 1) partials(rθϕ_gn.r, 2) partials(rθϕ_gn.r, 3);
                     partials(rθϕ_gn.θ, 1) partials(rθϕ_gn.θ, 2) partials(rθϕ_gn.θ, 3);
                     partials(rθϕ_gn.ϕ, 1) partials(rθϕ_gn.ϕ, 2) partials(rθϕ_gn.ϕ, 3) ]
        m = transform_deriv(s_from_cart, xyz)
        @test m ≈ m_gn

        rθϕ_gn = Spherical(Dual(3.7416573867739413, (1.0, 0.0, 0.0)), Dual(1.1071487177940904, (0.0, 1.0, 0.0)), Dual(0.9302740141154721, (0.0, 0.0, 1.0)))
        xyz_gn = cart_from_s(rθϕ_gn)
        m_gn = @SMatrix [partials(xyz_gn[1], 1) partials(xyz_gn[1], 2) partials(xyz_gn[1], 3);
                     partials(xyz_gn[2], 1) partials(xyz_gn[2], 2) partials(xyz_gn[2], 3);
                     partials(xyz_gn[3], 1) partials(xyz_gn[3], 2) partials(xyz_gn[3], 3) ]
        m = transform_deriv(cart_from_s, rθϕ)
        @test m ≈ m_gn

        # Octant 2
        xyz = SVector(-1.0, 2.0, 3.0)
        rθϕ = Spherical(3.7416573867739413, 2.0344439357957027, 0.9302740141154721)
        @test s_from_cart(xyz) ≈ rθϕ
        @test cart_from_s(rθϕ) ≈ xyz

        xyz_gn = SVector(Dual(-1.0, (1.0, 0.0, 0.0)), Dual(2.0, (0.0, 1.0, 0.0)), Dual(3.0, (0.0, 0.0, 1.0)))
        rθϕ_gn = s_from_cart(xyz_gn)
        m_gn = @SMatrix [partials(rθϕ_gn.r, 1) partials(rθϕ_gn.r, 2) partials(rθϕ_gn.r, 3);
                     partials(rθϕ_gn.θ, 1) partials(rθϕ_gn.θ, 2) partials(rθϕ_gn.θ, 3);
                     partials(rθϕ_gn.ϕ, 1) partials(rθϕ_gn.ϕ, 2) partials(rθϕ_gn.ϕ, 3) ]
        m = transform_deriv(s_from_cart, xyz)
        @test m ≈ m_gn

        rθϕ_gn = Spherical(Dual(3.7416573867739413, (1.0, 0.0, 0.0)), Dual(2.0344439357957027, (0.0, 1.0, 0.0)), Dual(0.9302740141154721, (0.0, 0.0, 1.0)))
        xyz_gn = cart_from_s(rθϕ_gn)
        m_gn = @SMatrix [partials(xyz_gn[1], 1) partials(xyz_gn[1], 2) partials(xyz_gn[1], 3);
                     partials(xyz_gn[2], 1) partials(xyz_gn[2], 2) partials(xyz_gn[2], 3);
                     partials(xyz_gn[3], 1) partials(xyz_gn[3], 2) partials(xyz_gn[3], 3) ]
        m = transform_deriv(cart_from_s, rθϕ)
        @test m ≈ m_gn

        # Octant 3
        xyz = SVector(1.0, -2.0, 3.0)
        rθϕ = Spherical(3.7416573867739413, -1.1071487177940904, 0.9302740141154721)
        @test s_from_cart(xyz) ≈ rθϕ
        @test cart_from_s(rθϕ) ≈ xyz

        xyz_gn = SVector(Dual(1.0, (1.0, 0.0, 0.0)), Dual(-2.0, (0.0, 1.0, 0.0)), Dual(3.0, (0.0, 0.0, 1.0)))
        rθϕ_gn = s_from_cart(xyz_gn)
        m_gn = @SMatrix [partials(rθϕ_gn.r, 1) partials(rθϕ_gn.r, 2) partials(rθϕ_gn.r, 3);
                     partials(rθϕ_gn.θ, 1) partials(rθϕ_gn.θ, 2) partials(rθϕ_gn.θ, 3);
                     partials(rθϕ_gn.ϕ, 1) partials(rθϕ_gn.ϕ, 2) partials(rθϕ_gn.ϕ, 3) ]
        m = transform_deriv(s_from_cart, xyz)
        @test m ≈ m_gn

        rθϕ_gn = Spherical(Dual(3.7416573867739413, (1.0, 0.0, 0.0)), Dual(-1.1071487177940904, (0.0, 1.0, 0.0)), Dual(0.9302740141154721, (0.0, 0.0, 1.0)))
        xyz_gn = cart_from_s(rθϕ_gn)
        m_gn = @SMatrix [partials(xyz_gn[1], 1) partials(xyz_gn[1], 2) partials(xyz_gn[1], 3);
                     partials(xyz_gn[2], 1) partials(xyz_gn[2], 2) partials(xyz_gn[2], 3);
                     partials(xyz_gn[3], 1) partials(xyz_gn[3], 2) partials(xyz_gn[3], 3) ]
        m = transform_deriv(cart_from_s, rθϕ)
        @test m ≈ m_gn

        # Octant 4
        xyz = SVector(-1.0, -2.0, 3.0)
        rθϕ = Spherical(3.7416573867739413, -2.0344439357957027, 0.9302740141154721)
        @test s_from_cart(xyz) ≈ rθϕ
        @test cart_from_s(rθϕ) ≈ xyz

        xyz_gn = SVector(Dual(-1.0, (1.0, 0.0, 0.0)), Dual(-2.0, (0.0, 1.0, 0.0)), Dual(3.0, (0.0, 0.0, 1.0)))
        rθϕ_gn = s_from_cart(xyz_gn)
        m_gn = @SMatrix [partials(rθϕ_gn.r, 1) partials(rθϕ_gn.r, 2) partials(rθϕ_gn.r, 3);
                     partials(rθϕ_gn.θ, 1) partials(rθϕ_gn.θ, 2) partials(rθϕ_gn.θ, 3);
                     partials(rθϕ_gn.ϕ, 1) partials(rθϕ_gn.ϕ, 2) partials(rθϕ_gn.ϕ, 3) ]
        m = transform_deriv(s_from_cart, xyz)
        @test m ≈ m_gn

        rθϕ_gn = Spherical(Dual(3.7416573867739413, (1.0, 0.0, 0.0)), Dual(-2.0344439357957027, (0.0, 1.0, 0.0)), Dual(0.9302740141154721, (0.0, 0.0, 1.0)))
        xyz_gn = cart_from_s(rθϕ_gn)
        m_gn = @SMatrix [partials(xyz_gn[1], 1) partials(xyz_gn[1], 2) partials(xyz_gn[1], 3);
                     partials(xyz_gn[2], 1) partials(xyz_gn[2], 2) partials(xyz_gn[2], 3);
                     partials(xyz_gn[3], 1) partials(xyz_gn[3], 2) partials(xyz_gn[3], 3) ]
        m = transform_deriv(cart_from_s, rθϕ)
        @test m ≈ m_gn

        # Octant 5
        xyz = SVector(1.0, 2.0, -3.0)
        rθϕ = Spherical(3.7416573867739413, 1.1071487177940904, -0.9302740141154721)
        @test s_from_cart(xyz) ≈ rθϕ
        @test cart_from_s(rθϕ) ≈ xyz

        xyz_gn = SVector(Dual(1.0, (1.0, 0.0, 0.0)), Dual(2.0, (0.0, 1.0, 0.0)), Dual(-3.0, (0.0, 0.0, 1.0)))
        rθϕ_gn = s_from_cart(xyz_gn)
        m_gn = @SMatrix [partials(rθϕ_gn.r, 1) partials(rθϕ_gn.r, 2) partials(rθϕ_gn.r, 3);
                     partials(rθϕ_gn.θ, 1) partials(rθϕ_gn.θ, 2) partials(rθϕ_gn.θ, 3);
                     partials(rθϕ_gn.ϕ, 1) partials(rθϕ_gn.ϕ, 2) partials(rθϕ_gn.ϕ, 3) ]
        m = transform_deriv(s_from_cart, xyz)
        @test m ≈ m_gn

        rθϕ_gn = Spherical(Dual(3.7416573867739413, (1.0, 0.0, 0.0)), Dual(1.1071487177940904, (0.0, 1.0, 0.0)), Dual(-0.9302740141154721, (0.0, 0.0, 1.0)))
        xyz_gn = cart_from_s(rθϕ_gn)
        m_gn = @SMatrix [partials(xyz_gn[1], 1) partials(xyz_gn[1], 2) partials(xyz_gn[1], 3);
                     partials(xyz_gn[2], 1) partials(xyz_gn[2], 2) partials(xyz_gn[2], 3);
                     partials(xyz_gn[3], 1) partials(xyz_gn[3], 2) partials(xyz_gn[3], 3) ]
        m = transform_deriv(cart_from_s, rθϕ)
        @test m ≈ m_gn

        # Octant 6
        xyz = SVector(-1.0, 2.0, -3.0)
        rθϕ = Spherical(3.7416573867739413, 2.0344439357957027, -0.9302740141154721)
        @test s_from_cart(xyz) ≈ rθϕ
        @test cart_from_s(rθϕ) ≈ xyz

        xyz_gn = SVector(Dual(-1.0, (1.0, 0.0, 0.0)), Dual(2.0, (0.0, 1.0, 0.0)), Dual(-3.0, (0.0, 0.0, 1.0)))
        rθϕ_gn = s_from_cart(xyz_gn)
        m_gn = @SMatrix [partials(rθϕ_gn.r, 1) partials(rθϕ_gn.r, 2) partials(rθϕ_gn.r, 3);
                     partials(rθϕ_gn.θ, 1) partials(rθϕ_gn.θ, 2) partials(rθϕ_gn.θ, 3);
                     partials(rθϕ_gn.ϕ, 1) partials(rθϕ_gn.ϕ, 2) partials(rθϕ_gn.ϕ, 3) ]
        m = transform_deriv(s_from_cart, xyz)
        @test m ≈ m_gn

        rθϕ_gn = Spherical(Dual(3.7416573867739413, (1.0, 0.0, 0.0)), Dual(2.0344439357957027, (0.0, 1.0, 0.0)), Dual(-0.9302740141154721, (0.0, 0.0, 1.0)))
        xyz_gn = cart_from_s(rθϕ_gn)
        m_gn = @SMatrix [partials(xyz_gn[1], 1) partials(xyz_gn[1], 2) partials(xyz_gn[1], 3);
                     partials(xyz_gn[2], 1) partials(xyz_gn[2], 2) partials(xyz_gn[2], 3);
                     partials(xyz_gn[3], 1) partials(xyz_gn[3], 2) partials(xyz_gn[3], 3) ]
        m = transform_deriv(cart_from_s, rθϕ)
        @test m ≈ m_gn

        # Octant 7
        xyz = SVector(1.0, -2.0, -3.0)
        rθϕ = Spherical(3.7416573867739413, -1.1071487177940904, -0.9302740141154721)
        @test s_from_cart(xyz) ≈ rθϕ
        @test cart_from_s(rθϕ) ≈ xyz

        xyz_gn = SVector(Dual(1.0, (1.0, 0.0, 0.0)), Dual(-2.0, (0.0, 1.0, 0.0)), Dual(-3.0, (0.0, 0.0, 1.0)))
        rθϕ_gn = s_from_cart(xyz_gn)
        m_gn = @SMatrix [partials(rθϕ_gn.r, 1) partials(rθϕ_gn.r, 2) partials(rθϕ_gn.r, 3);
                     partials(rθϕ_gn.θ, 1) partials(rθϕ_gn.θ, 2) partials(rθϕ_gn.θ, 3);
                     partials(rθϕ_gn.ϕ, 1) partials(rθϕ_gn.ϕ, 2) partials(rθϕ_gn.ϕ, 3) ]
        m = transform_deriv(s_from_cart, xyz)
        @test m ≈ m_gn

        rθϕ_gn = Spherical(Dual(3.7416573867739413, (1.0, 0.0, 0.0)), Dual(-1.1071487177940904, (0.0, 1.0, 0.0)), Dual(-0.9302740141154721, (0.0, 0.0, 1.0)))
        xyz_gn = cart_from_s(rθϕ_gn)
        m_gn = @SMatrix [partials(xyz_gn[1], 1) partials(xyz_gn[1], 2) partials(xyz_gn[1], 3);
                     partials(xyz_gn[2], 1) partials(xyz_gn[2], 2) partials(xyz_gn[2], 3);
                     partials(xyz_gn[3], 1) partials(xyz_gn[3], 2) partials(xyz_gn[3], 3) ]
        m = transform_deriv(cart_from_s, rθϕ)
        @test m ≈ m_gn

        # Octant 8
        xyz = SVector(-1.0, -2.0, -3.0)
        rθϕ = Spherical(3.7416573867739413, -2.0344439357957027, -0.9302740141154721)
        @test s_from_cart(xyz) ≈ rθϕ
        @test cart_from_s(rθϕ) ≈ xyz

        xyz_gn = SVector(Dual(-1.0, (1.0, 0.0, 0.0)), Dual(-2.0, (0.0, 1.0, 0.0)), Dual(-3.0, (0.0, 0.0, 1.0)))
        rθϕ_gn = s_from_cart(xyz_gn)
        m_gn = @SMatrix [partials(rθϕ_gn.r, 1) partials(rθϕ_gn.r, 2) partials(rθϕ_gn.r, 3);
                     partials(rθϕ_gn.θ, 1) partials(rθϕ_gn.θ, 2) partials(rθϕ_gn.θ, 3);
                     partials(rθϕ_gn.ϕ, 1) partials(rθϕ_gn.ϕ, 2) partials(rθϕ_gn.ϕ, 3) ]
        m = transform_deriv(s_from_cart, xyz)
        @test m ≈ m_gn

        rθϕ_gn = Spherical(Dual(3.7416573867739413, (1.0, 0.0, 0.0)), Dual(-2.0344439357957027, (0.0, 1.0, 0.0)), Dual(-0.9302740141154721, (0.0, 0.0, 1.0)))
        xyz_gn = cart_from_s(rθϕ_gn)
        m_gn = @SMatrix [partials(xyz_gn[1], 1) partials(xyz_gn[1], 2) partials(xyz_gn[1], 3);
                     partials(xyz_gn[2], 1) partials(xyz_gn[2], 2) partials(xyz_gn[2], 3);
                     partials(xyz_gn[3], 1) partials(xyz_gn[3], 2) partials(xyz_gn[3], 3) ]
        m = transform_deriv(cart_from_s, rθϕ)
        @test m ≈ m_gn

        # Cylindrical <-> Cartesian
        # test all 4 quadrants of the xy-plane (for consistency of branch-cuts)

        # First quadrant
        xyz = SVector(1.0, 2.0, 3.0)
        rθz = Cylindrical(2.23606797749979, 1.1071487177940904, 3.0)
        @test cyl_from_cart(xyz) ≈ rθz
        @test cyl_from_cart(collect(xyz)) ≈ rθz
        @test cart_from_cyl(rθz) ≈ xyz

        xyz_gn = SVector(Dual(1.0, (1.0, 0.0, 0.0)), Dual(2.0, (0.0, 1.0, 0.0)), Dual(3.0, (0.0, 0.0, 1.0)))
        rθz_gn = cyl_from_cart(xyz_gn)
        m_gn = @SMatrix [partials(rθz_gn.r, 1) partials(rθz_gn.r, 2) partials(rθz_gn.r, 3);
                     partials(rθz_gn.θ, 1) partials(rθz_gn.θ, 2) partials(rθz_gn.θ, 3);
                     partials(rθz_gn.z, 1) partials(rθz_gn.z, 2) partials(rθz_gn.z, 3) ]
        m = transform_deriv(cyl_from_cart, xyz)
        @test m ≈ m_gn

        rθz_gn = Cylindrical(Dual(2.23606797749979, (1.0, 0.0, 0.0)), Dual(1.1071487177940904, (0.0, 1.0, 0.0)), Dual(3.0, (0.0, 0.0, 1.0)))
        xyz_gn = cart_from_cyl(rθz_gn)
        m_gn = @SMatrix [partials(xyz_gn[1], 1) partials(xyz_gn[1], 2) partials(xyz_gn[1], 3);
                     partials(xyz_gn[2], 1) partials(xyz_gn[2], 2) partials(xyz_gn[2], 3);
                     partials(xyz_gn[3], 1) partials(xyz_gn[3], 2) partials(xyz_gn[3], 3) ]
        m = transform_deriv(cart_from_cyl, rθz)
        @test m ≈ m_gn

        # Second quadrant
        xyz = SVector(-1.0, 2.0, 3.0)
        rθz = Cylindrical(2.23606797749979, 2.0344439357957027, 3.0)
        @test cyl_from_cart(xyz) ≈ rθz
        @test cart_from_cyl(rθz) ≈ xyz

        xyz_gn = SVector(Dual(-1.0, (1.0, 0.0, 0.0)), Dual(2.0, (0.0, 1.0, 0.0)), Dual(3.0, (0.0, 0.0, 1.0)))
        rθz_gn = cyl_from_cart(xyz_gn)
        m_gn = @SMatrix [partials(rθz_gn.r, 1) partials(rθz_gn.r, 2) partials(rθz_gn.r, 3);
                     partials(rθz_gn.θ, 1) partials(rθz_gn.θ, 2) partials(rθz_gn.θ, 3);
                     partials(rθz_gn.z, 1) partials(rθz_gn.z, 2) partials(rθz_gn.z, 3) ]
        m = transform_deriv(cyl_from_cart, xyz)
        @test m ≈ m_gn

        rθz_gn = Cylindrical(Dual(2.23606797749979, (1.0, 0.0, 0.0)), Dual(2.0344439357957027, (0.0, 1.0, 0.0)), Dual(3.0, (0.0, 0.0, 1.0)))
        xyz_gn = cart_from_cyl(rθz_gn)
        m_gn = @SMatrix [partials(xyz_gn[1], 1) partials(xyz_gn[1], 2) partials(xyz_gn[1], 3);
                     partials(xyz_gn[2], 1) partials(xyz_gn[2], 2) partials(xyz_gn[2], 3);
                     partials(xyz_gn[3], 1) partials(xyz_gn[3], 2) partials(xyz_gn[3], 3) ]
        m = transform_deriv(cart_from_cyl, rθz)
        @test m ≈ m_gn

        # Third quadrant
        xyz = SVector(1.0, -2.0, 3.0)
        rθz = Cylindrical(2.23606797749979, -1.1071487177940904, 3.0)
        @test cyl_from_cart(xyz) ≈ rθz
        @test cart_from_cyl(rθz) ≈ xyz

        xyz_gn = SVector(Dual(1.0, (1.0, 0.0, 0.0)), Dual(-2.0, (0.0, 1.0, 0.0)), Dual(3.0, (0.0, 0.0, 1.0)))
        rθz_gn = cyl_from_cart(xyz_gn)
        m_gn = @SMatrix [partials(rθz_gn.r, 1) partials(rθz_gn.r, 2) partials(rθz_gn.r, 3);
                     partials(rθz_gn.θ, 1) partials(rθz_gn.θ, 2) partials(rθz_gn.θ, 3);
                     partials(rθz_gn.z, 1) partials(rθz_gn.z, 2) partials(rθz_gn.z, 3) ]
        m = transform_deriv(cyl_from_cart, xyz)
        @test m ≈ m_gn

        rθz_gn = Cylindrical(Dual(2.23606797749979, (1.0, 0.0, 0.0)), Dual(-1.1071487177940904, (0.0, 1.0, 0.0)), Dual(3.0, (0.0, 0.0, 1.0)))
        xyz_gn = cart_from_cyl(rθz_gn)
        m_gn = @SMatrix [partials(xyz_gn[1], 1) partials(xyz_gn[1], 2) partials(xyz_gn[1], 3);
                     partials(xyz_gn[2], 1) partials(xyz_gn[2], 2) partials(xyz_gn[2], 3);
                     partials(xyz_gn[3], 1) partials(xyz_gn[3], 2) partials(xyz_gn[3], 3) ]
        m = transform_deriv(cart_from_cyl, rθz)
        @test m ≈ m_gn

        # Fourth quadrant
        xyz = SVector(-1.0, -2.0, 3.0)
        rθz = Cylindrical(2.23606797749979, -2.0344439357957027, 3.0)
        @test cyl_from_cart(xyz) ≈ rθz
        @test cart_from_cyl(rθz) ≈ xyz

        xyz_gn = SVector(Dual(-1.0, (1.0, 0.0, 0.0)), Dual(-2.0, (0.0, 1.0, 0.0)), Dual(3.0, (0.0, 0.0, 1.0)))
        rθz_gn = cyl_from_cart(xyz_gn)
        m_gn = @SMatrix [partials(rθz_gn.r, 1) partials(rθz_gn.r, 2) partials(rθz_gn.r, 3);
                     partials(rθz_gn.θ, 1) partials(rθz_gn.θ, 2) partials(rθz_gn.θ, 3);
                     partials(rθz_gn.z, 1) partials(rθz_gn.z, 2) partials(rθz_gn.z, 3) ]
        m = transform_deriv(cyl_from_cart, xyz)
        @test m ≈ m_gn

        rθz_gn = Cylindrical(Dual(2.23606797749979, (1.0, 0.0, 0.0)), Dual(-2.0344439357957027, (0.0, 1.0, 0.0)), Dual(3.0, (0.0, 0.0, 1.0)))
        xyz_gn = cart_from_cyl(rθz_gn)
        m_gn = @SMatrix [partials(xyz_gn[1], 1) partials(xyz_gn[1], 2) partials(xyz_gn[1], 3);
                     partials(xyz_gn[2], 1) partials(xyz_gn[2], 2) partials(xyz_gn[2], 3);
                     partials(xyz_gn[3], 1) partials(xyz_gn[3], 2) partials(xyz_gn[3], 3) ]
        m = transform_deriv(cart_from_cyl, rθz)
        @test m ≈ m_gn

        # Spherical <-> Cartesian
        # Just composes at the moment, so a single testcase suffices
        rθϕ = Spherical(3.7416573867739413, 1.1071487177940904, 0.9302740141154721)
        rθz = Cylindrical(2.23606797749979, 1.1071487177940904, 3.0)
        @test cyl_from_s(rθϕ) ≈ rθz
        @test s_from_cyl(rθz) ≈ rθϕ

        rθϕ_gn = Spherical(Dual(3.7416573867739413, (1.0, 0.0, 0.0)), Dual(1.1071487177940904, (0.0, 1.0, 0.0)), Dual(0.9302740141154721, (0.0, 0.0, 1.0)))
        rθz_gn = cyl_from_s(rθϕ_gn)
        m_gn = @SMatrix [partials(rθz_gn.r, 1) partials(rθz_gn.r, 2) partials(rθz_gn.r, 3);
                     partials(rθz_gn.θ, 1) partials(rθz_gn.θ, 2) partials(rθz_gn.θ, 3);
                     partials(rθz_gn.z, 1) partials(rθz_gn.z, 2) partials(rθz_gn.z, 3) ]
        m = transform_deriv(cyl_from_s, rθϕ)
        #@test isapprox(m, m_gn; atol = 1e-12)
        for (m1,m2) in zip(m,m_gn) # Unfortunately, FixedSizeArrays doesn't pass the keyword arguments to isapprox...
            @test isapprox(m1, m2; atol=1e-12)
        end

        rθz_gn = Cylindrical(Dual(2.23606797749979, (1.0, 0.0, 0.0)), Dual(1.1071487177940904, (0.0, 1.0, 0.0)), Dual(3.0, (0.0, 0.0, 1.0)))
        rθϕ_gn = s_from_cyl(rθz_gn)
        m_gn = @SMatrix [partials(rθϕ_gn.r, 1) partials(rθϕ_gn.r, 2) partials(rθϕ_gn.r, 3);
                     partials(rθϕ_gn.θ, 1) partials(rθϕ_gn.θ, 2) partials(rθϕ_gn.θ, 3);
                     partials(rθϕ_gn.ϕ, 1) partials(rθϕ_gn.ϕ, 2) partials(rθϕ_gn.ϕ, 3) ]
        m = transform_deriv(s_from_cyl, rθz)
        #@test isapprox(m, m_gn; atol = 1e-12)
        @test m ≈ m_gn

        @testset "Common types" begin
            xyz = SVector(1.0, 2.0, 3.0)
            xyz_i = SVector(1, 2, 3)

            @testset "Spherical" begin
                rθϕ = Spherical(3.7416573867739413, 1.1071487177940904, 0.9302740141154721)

                @test s_from_cart(xyz) ≈ rθϕ
                @test s_from_cart(xyz_i) ≈ rθϕ
                @test s_from_cart(collect(xyz)) ≈ rθϕ
                @test cart_from_s(rθϕ) ≈ xyz

                s1 = Spherical(1, 2.0, 3.0)
                s2 = Spherical(1.0, 2, 3)
                s3 = Spherical{Int,Int}(1, 2, 3)

                @test typeof(s1.r) == typeof(s1.θ) == typeof(s1.ϕ) == Float64
                @test typeof(s2.r) == typeof(s2.θ) == typeof(s2.ϕ) == Float64
                @test typeof(s3.r) == typeof(s3.θ) == typeof(s3.ϕ) == Int
            end

            @testset "Cylindrical" begin
                rθz = Cylindrical(2.23606797749979, 1.1071487177940904, 3.0)

                @test cyl_from_cart(xyz) ≈ rθz
                @test cyl_from_cart(xyz_i) ≈ rθz
                @test cyl_from_cart(collect(xyz)) ≈ rθz
                @test cart_from_cyl(rθz) ≈ xyz

                c1 = Cylindrical(1, 2.0, 3)
                c2 = Cylindrical(1.0, 2, 3.0)
                c3 = Cylindrical(1, 2, 3)
                c4 = Cylindrical{Int,Int}(1, 2, 3)

                @test typeof(c1.r) == typeof(c1.z) == typeof(c1.θ) == Float64
                @test typeof(c2.r) == typeof(c2.θ) == typeof(c2.z) == Float64
                @test typeof(cyl_from_cart(xyz_i).r) == typeof(cyl_from_cart(xyz_i).z) == Float64
                @test c3 == c4
            end
        end

        @testset "Units" begin
            xyz = SVector(1.0, 2.0, 3.0)u"m"

            @testset "Shperical" begin
                rθϕ = Spherical(3.7416573867739413u"m", 1.1071487177940904, 0.9302740141154721)

                @test s_from_cart(xyz) ≈ rθϕ
                @test typeof(s_from_cart(xyz)) == typeof(rθϕ)
                @test s_from_cart(collect(xyz)) ≈ rθϕ
                @test cart_from_s(rθϕ) ≈ xyz
            end
            @testset "Cylindrical" begin
                rθz = Cylindrical(2.23606797749979u"m", 1.1071487177940904, 3.0u"m")

                @test cyl_from_cart(xyz) ≈ rθz
                @test typeof(cyl_from_cart(xyz)) == typeof(rθz)
                @test cyl_from_cart(collect(xyz)) ≈ rθz
                @test cart_from_cyl(rθz) ≈ xyz
            end
        end
    end
end

@testset "Perspective transformation" begin
    @test PerspectiveMap()([2.0, -1.0, 0.5]) ≈ [4.0, -2.0]

    if VERSION >= v"0.6.0-dev.948"
        @test cameramap(2.0)                  ≈ LinearMap(UniformScaling(2.0)) ∘ PerspectiveMap()
        @test cameramap((1.1,2.2))            ≈ LinearMap([1.1 0; 0 2.2]) ∘ PerspectiveMap()
        @test cameramap(1.1,       (3.3,4.4)) ≈ Translation([-3.3,-4.4]) ∘ LinearMap(UniformScaling(1.1)) ∘ PerspectiveMap()
        @test cameramap((1.1,2.2), (3.3,4.4)) ≈ Translation([-3.3,-4.4]) ∘ LinearMap([1.1 0; 0 2.2]) ∘ PerspectiveMap()
    else
        # `isapprox` for `UniformScaling` not defined. Just put a few points through and
        # test that we get the same results
        points = [[1.0,1.0,1.0], [-1.0,1.0,1.0], [-1.0,-1.0,1.0], [1.0,-1.0,1.0]]

        trans1 = cameramap(2.0)
        trans2 = LinearMap(UniformScaling(2.0)) ∘ PerspectiveMap()
        @test all(isapprox.(trans1.(points), trans2.(points)))

        trans1 = cameramap((1.1,2.2))
        trans2 = LinearMap([1.1 0; 0 2.2]) ∘ PerspectiveMap()
        @test all(isapprox.(trans1.(points), trans2.(points)))

        trans1 = cameramap(1.1,       (3.3,4.4))
        trans2 = Translation([-3.3,-4.4]) ∘ LinearMap(UniformScaling(1.1)) ∘ PerspectiveMap()
        @test all(isapprox.(trans1.(points), trans2.(points)))

        trans1 = cameramap((1.1,2.2), (3.3,4.4))
        trans2 = Translation([-3.3,-4.4]) ∘ LinearMap([1.1 0; 0 2.2]) ∘ PerspectiveMap()
        @test all(isapprox.(trans1.(points), trans2.(points)))

    end
end

module CoordinateTransformations

using StaticArrays
using LinearAlgebra

# Core methods
export compose, ∘, transform_deriv, transform_deriv_params, recenter
export Transformation, IdentityTransformation

# 2D coordinate systems and their transformations
export Polar
export PolarFromCartesian, CartesianFromPolar

# 3D coordinate systems and their transformations
export Spherical, Cylindrical
export SphericalFromCartesian, CartesianFromSpherical,
       CylindricalFromCartesian, CartesianFromCylindrical,
       CylindricalFromSpherical, SphericalFromCylindrical

# Common transformations
export AbstractAffineMap
export AffineMap, LinearMap, Translation
export PerspectiveMap, cameramap
export kabsch

include("core.jl")
include("coordinatesystems.jl")
include("affine.jl")
include("perspective.jl")
include("kabsch.jl")

end # module

"""
    abstract type AbstractAffineMap <: Transformation

`AbstractAffineMap` is the supertype of all affine transformations,
including linear transformations.
"""
abstract type AbstractAffineMap <: Transformation end

"""
    Translation(v) <: AbstractAffineMap
    Translation(dx, dy)         # 2D
    Translation(dx, dy, dz)     # 3D

Construct the `Translation` transformation for translating Cartesian points by
an offset `v = (dx, dy, ...)`
"""
struct Translation{V} <: AbstractAffineMap
    translation::V
end
Translation(x::Tuple) = Translation(SVector(x))
Translation(x,y) = Translation(SVector(x,y))
Translation(x,y,z) = Translation(SVector(x,y,z))
Base.show(io::IO, trans::Translation) = print(io, "Translation$((trans.translation...,))")

function (trans::Translation{V})(x) where {V}
    x + trans.translation
end

Base.inv(trans::Translation) = Translation(-trans.translation)

function compose(trans1::Translation, trans2::Translation)
    Translation(trans1.translation + trans2.translation)
end

transform_deriv(trans::Translation, x) = I
transform_deriv_params(trans::Translation, x) = I

function Base.isapprox(t1::Translation, t2::Translation; kwargs...)
    isapprox(t1.translation, t2.translation; kwargs...)
end


"""
    LinearMap <: AbstractAffineMap
    LinearMap(M)

A general linear transformation, constructed using `LinearMap(M)`
for any matrix-like object `M`.
"""
struct LinearMap{M} <: AbstractAffineMap
    linear::M
end
function Base.show(io::IO, trans::LinearMap)
    print(io, "LinearMap(", trans.linear, ")")
end

function (trans::LinearMap{M})(x) where {M}
    trans.linear * x
end
(trans::LinearMap{M})(x::Tuple) where {M} = trans(SVector(x))

Base.inv(trans::LinearMap) = LinearMap(inv(trans.linear))

compose(t1::LinearMap, t2::LinearMap) = LinearMap(t1.linear * t2.linear)

function Base.isapprox(t1::LinearMap, t2::LinearMap; kwargs...)
    isapprox(t1.linear, t2.linear; kwargs...)
end

function Base.isapprox(t1::LinearMap, t2::Translation; kwargs...)
    isapprox(t1.linear, one(t1.linear); kwargs...) &&
        isapprox(norm(t2.translation),0; kwargs...)
end

function Base.isapprox(t1::Translation, t2::LinearMap; kwargs...)
    isapprox(norm(t1.translation), 0; kwargs...) &&
        isapprox(t2.linear, one(t2.linear); kwargs...)
end

function Base.:(==)(t1::LinearMap, t2::Translation)
    isone(t1.linear) &&
        0 == norm(t2.translation)
end

function Base.:(==)(t1::Translation, t2::LinearMap)
    norm(t1.translation) == 0 &&
        isone(t2.linear)
end

transform_deriv(trans::LinearMap, x) = trans.linear
# TODO transform_deriv_params

"""
    AffineMap <: AbstractAffineMap

A concrete affine transformation.  To construct the mapping `x -> M*x + v`, use

    AffineMap(M, v)

where `M` is a matrix and `v` a vector.  An arbitrary `Transformation` may be
converted into an affine approximation by linearizing about a point `x` using

    AffineMap(trans, [x])

For transformations which are already affine, `x` may be omitted.
"""
struct AffineMap{M, V} <: AbstractAffineMap
    linear::M
    translation::V
end

function (trans::AffineMap)(x)
    l = LinearMap(trans.linear)
    t = Translation(trans.translation)
    t(l(x))
end

# Note: the expression `Tx - dT*Tx` will have large cancellation error for
# large Tx!  However, changing the order of applying the matrix and
# translation won't fix things, because then we'd have `Tx*(x-x0)` which
# also can incur large cancellation error in `x-x0`.
"""
    AffineMap(trans::Transformation, x0)

Create an affine transformation corresponding to the differential transformation
of `x0 + dx` according to `trans`, i.e. the Affine transformation that is
locally most accurate in the vicinity of `x0`.
"""
function AffineMap(trans::Transformation, x0)
    dT = transform_deriv(trans, x0)
    Tx = trans(x0)
    AffineMap(dT, Tx - dT*x0)
end

function Base.show(io::IO, trans::AffineMap)
    print(io, "AffineMap(", trans.linear, ", ", trans.translation, ")")
end

function compose(t1::Translation, t2::LinearMap)
    AffineMap(t2.linear, t1.translation)
end

function compose(t1::LinearMap, t2::Translation)
    AffineMap(t1.linear, t1.linear * t2.translation)
end

function compose(t1::AffineMap, t2::AffineMap)
    AffineMap(t1.linear * t2.linear, t1.translation + t1.linear * t2.translation)
end

function compose(t1::AffineMap, t2::LinearMap)
    AffineMap(t1.linear * t2.linear, t1.translation)
end

function compose(t1::LinearMap, t2::AffineMap)
    AffineMap(t1.linear * t2.linear, t1.linear * t2.translation)
end

function compose(t1::AffineMap, t2::Translation)
    AffineMap(t1.linear, t1.translation + t1.linear * t2.translation)
end

function compose(t1::Translation, t2::AffineMap)
    AffineMap(t2.linear, t1.translation + t2.translation)
end

function Base.inv(trans::AffineMap)
    m_inv = inv(trans.linear)
    AffineMap(m_inv, m_inv * (-trans.translation))
end

function Base.isapprox(t1::AffineMap, t2::AffineMap; kwargs...)
    isapprox(t1.linear, t2.linear; kwargs...) &&
        isapprox(t1.translation, t2.translation; kwargs...)
end

function Base.isapprox(t1::AffineMap, t2::Translation; kwargs...)
    isapprox(t1.linear, one(t1.linear); kwargs...) &&
        isapprox(t1.translation, t2.translation; kwargs...)
end

function Base.isapprox(t1::Translation, t2::AffineMap; kwargs...)
    isapprox(t2.linear, one(t2.linear); kwargs...) &&
        isapprox(t1.translation, t2.translation; kwargs...)
end

function Base.isapprox(t1::AffineMap, t2::LinearMap; kwargs...)
    isapprox(t1.linear, t2.linear; kwargs...) &&
        isapprox(norm(t1.translation), 0; kwargs...)
end

function Base.isapprox(t1::LinearMap, t2::AffineMap; kwargs...)
    isapprox(t1.linear, t2.linear; kwargs...) &&
        isapprox(0, norm(t2.translation); kwargs...)
end


function Base.:(==)(t1::AffineMap, t2::Translation)
    isone(t1.linear) &&
        t1.translation == t2.translation
end

function Base.:(==)(t1::Translation, t2::AffineMap)
    isone(t2.linear) &&
        t1.translation == t2.translation
end

function Base.:(==)(t1::AffineMap, t2::LinearMap)
    t1.linear == t2.linear &&
        norm(t1.translation) == 0
end

function Base.:(==)(t1::LinearMap, t2::AffineMap)
    t1.linear == t2.linear &&
        0 == norm(t2.translation)
end

recenter(trans::AbstractMatrix, origin::Union{AbstractVector, Tuple}) = recenter(LinearMap(trans), origin)

transform_deriv(trans::AffineMap, x) = trans.linear
# TODO transform_deriv_params

"""
    AffineMap(from_points => to_points) → trans

Create an Affine transformation that approximately maps the `from` points to the `to` points.
At least `n+1` non-degenerate points are required to map an `n`-dimensional space.
If there are more points than this, the transformation will be over-determined
and a least-squares solution will be computed.
"""
function AffineMap((from_points,to_points)::Pair)
    M = column_matrix(to_points) * pinv(column_matrix(from_points, 1))
    AffineMap(M[:, 1:end-1], M[:, end])
end

column_matrix(points::AbstractMatrix) = points
column_matrix(points) = reduce(hcat, points)

column_matrix(points::AbstractMatrix, lastval) = vcat(points, fill(lastval, 1, axes(points, 2)))
column_matrix(points, lastval) = reduce(hcat, [vcat(point, lastval) for point in points])

"""
    PerspectiveMap()

Construct a perspective transformation. The perspective transformation takes,
e.g., a point in 3D space and "projects" it onto a 2D virtual screen of an ideal
pinhole camera (at distance `1` away from the camera). The camera is oriented
towards the positive-Z axis (or in general, along the final dimension) and the
sign of the `x` and `y` components is preserved for objects in front of the
camera (objects behind the camera are also projected and therefore inverted - it
is up to the user to cull these as necessary).

This transformation is designed to be used in composition with other coordinate
transformations, defining e.g. the position and orientation of the camera. For
example:

```julia
cam_transform = PerspectiveMap() ∘ inv(AffineMap(cam_rotation, cam_position))
screen_points = map(cam_transform, points)
```

(see also [`cameramap`](@ref))
"""
struct PerspectiveMap <: Transformation
end

function (::PerspectiveMap)(v::AbstractVector)
    scale =  1/v[end]
    return [v[i] * scale for i in 1:length(v)-1]
end

@inline function (::PerspectiveMap)(v::StaticVector)
    return pop(v) * inv(v[end])
end

Base.isapprox(::PerspectiveMap, ::PerspectiveMap; kwargs...) = true

"""
    cameramap()
    cameramap(scale)
    cameramap(scale, offset)

Create a transformation that takes points in real space (e.g. 3D) and projects
them through a perspective transformation onto the focal plane of an ideal
(pinhole) camera with the given properties.

The `scale` sets the scale of the screen. For a standard digital camera, this
would be `scale = focal_length / pixel_size`. Non-square pixels are supported
by providing a pair of scales in a tuple, `scale = (scale_x, scale_y)`. Positive
scales represent a camera looking in the +z axis with a virtual screen in front
of the camera (the x,y coordinates are not inverted compared to 3D space). Note
that points behind the camera (with negative z component) will be projected
(and inverted) onto the image coordinates and it is up to the user to cull
such points as necessary.

The `offset = (offset_x, offset_y)` is used to define the origin in the imaging
plane. For instance, you may wish to have the point (0,0) represent the top-left
corner of your imaging sensor. This measurement is in the units after applying
`scale` (e.g. pixels).

(see also [`PerspectiveMap`](@ref))
"""
cameramap() = PerspectiveMap()
cameramap(scale::Number) =
    LinearMap(UniformScaling(scale)) ∘ PerspectiveMap()
cameramap(scale::Tuple{Number, Number}) =
    LinearMap(@SMatrix([scale[1] 0; 0 scale[2]])) ∘ PerspectiveMap()
cameramap(scale::Number, offset::Tuple{Number,Number}) =
    AffineMap(UniformScaling(scale), SVector(-offset[1], -offset[2])) ∘ PerspectiveMap()
cameramap(scale::Tuple{Number, Number}, offset::Tuple{Number,Number}) =
    AffineMap(@SMatrix([scale[1] 0; 0 scale[2]]), SVector(-offset[1], -offset[2])) ∘ PerspectiveMap()

using Test
using LinearAlgebra
using CoordinateTransformations
using ForwardDiff: Dual, partials
using StaticArrays
using Unitful
using Documenter
using Aqua

@testset "CoordinateTransformations" begin
    include("core.jl")
    include("coordinatesystems.jl")
    include("affine.jl")
    include("perspective.jl")

    Aqua.test_all(CoordinateTransformations)

    DocMeta.setdocmeta!(
        CoordinateTransformations,
        :DocTestSetup,
        :(using CoordinateTransformations),
        recursive=true,
    )
    doctest(CoordinateTransformations, manual=true)
end

@testset "Core definitions" begin
    # Can't do much without a transformation, and the only one defined in
    # core.jl is IdentityTransformation... will have to test
    # ComposeTransformation in test/commontransformations.jl
    identity_trans = IdentityTransformation()

    @test inv(identity_trans) == identity_trans

    @test identity_trans ∘ identity_trans == identity_trans

    x = SVector(1.0, 2.0, 3.0)
    @test identity_trans(x) == x
end

# API Reference

## Transformations
```@docs
Transformation
CoordinateTransformations.ComposedTransformation
IdentityTransformation
PerspectiveMap
inv
cameramap
compose
recenter
transform_deriv
transform_deriv_params
```

## Affine maps
```@docs
AbstractAffineMap
AffineMap
AffineMap(::Transformation, ::Any)
AffineMap(::Pair)
LinearMap
Translation
kabsch
```

## 2D Coordinates
```@docs
Polar
PolarFromCartesian
CartesianFromPolar
```

## 3D Coordinates
```@docs
Cylindrical
Spherical
```

```@docs
CartesianFromCylindrical
CartesianFromSpherical
CylindricalFromCartesian
CylindricalFromSpherical
SphericalFromCartesian
SphericalFromCylindrical
```

```@meta
DocTestSetup = quote
    using CoordinateTransformations
end
```
# CoordinateTransformations

[![Build Status](https://github.com/JuliaGeometry/CoordinateTransformations.jl/workflows/CI/badge.svg)](https://github.com/JuliaGeometry/CoordinateTransformations.jl/actions?query=workflow%3ACI)

**CoordinateTransformations** is a Julia package to manage simple or complex
networks of coordinate system transformations. Transformations can be easily
applied, inverted, composed, and differentiated (both with respect to the
input coordinates and with respect to transformation parameters such as rotation
angle). Transformations are designed to be light-weight and efficient enough
for, e.g., real-time graphical applications, while support for both explicit
and automatic differentiation makes it easy to perform optimization and
therefore ideal for computer vision applications such as SLAM (simultaneous
localization and mapping).

The package provide two main pieces of functionality

1. Primarily, an interface for defining `Transformation`s and applying
   (by calling), inverting (`inv()`), composing (`∘` or `compose()`) and
   differentiating (`transform_deriv()` and `transform_deriv_params()`) them.

2. A small set of built-in, composable, primitive transformations for
   transforming 2D and 3D points (optionally leveraging the *StaticArrays*
   and *Rotations* packages).

## Quick start

Let's translate a 3D point:
```julia
using CoordinateTransformations, Rotations, StaticArrays

x = SVector(1.0, 2.0, 3.0)  # SVector is provided by StaticArrays.jl
trans = Translation(3.5, 1.5, 0.0)

y = trans(x)
```

We can either apply different transformations in turn,
```julia
rot = LinearMap(RotX(0.3))  # Rotate 0.3 radians about X-axis, from Rotations.jl

z = trans(rot(x))
```
or build a composed transformation using the `∘` operator (accessible at the
REPL by typing `\circ` then tab):
```julia
composed = trans ∘ rot  # alternatively, use compose(trans, rot)

composed(x) == z
```
A composition of a `Translation` and a `LinearMap` results in an `AffineMap`.

We can invert the transformation:
```julia
composed_inv = inv(composed)

composed_inv(z) == x
```

For any transformation, we can shift the origin to a new point using `recenter`:
```julia
rot_around_x = recenter(rot, x)
```
Now `rot_around_x` is a rotation around the point `x = SVector(1.0, 2.0, 3.0)`.


Finally, we can construct a matrix describing how the components of `z`
differentiates with respect to components of `x`:
```julia
# In general, the transform may be non-linear, and thus we require
# the value of x to compute the derivative
∂z_∂x = transform_deriv(composed, x)
```

Or perhaps we want to know how `y` will change with respect to changes of
to the translation parameters:
```julia
∂y_∂θ = transform_deriv_params(trans, x)
```

## Interface

Transformations are derived from `Transformation`. As an example, we have
`Translation{T} <: Transformation`. A `Translation` will accept and translate
points in a variety of formats, such as `Vector` or `SVector`, but in general
your custom-defined `Transformation`s could transform any Julia object.

Transformations can be reversed using `inv(trans)`. They can be chained
together using the `∘` operator (`trans1 ∘ trans2`) or `compose` function (`compose(trans1, trans2)`).
In this case, `trans2` is applied first to the data, before `trans1`.
Composition may be intelligent, for instance by precomputing a new `Translation`
by summing the elements of two existing `Translation`s, and yet other
transformations may compose to the `IdentityTransformation`. But by default,
composition will result in a `ComposedTransformation` object which simply
dispatches to apply the transformations in the correct order.

Finally, the matrix describing how differentials propagate through a transform
can be calculated with the `transform_deriv(trans, x)` method. The derivatives
of how the output depends on the transformation parameters is accessed via
`transform_deriv_params(trans, x)`. Users currently have to overload these methods,
as no fall-back automatic differentiation is currently included. Alternatively,
all the built-in types and transformations are compatible with automatic differentiation
techniques, and can be parameterized by *DualNumbers*' `DualNumber` or *ForwardDiff*'s `Dual`.

## Built-in transformations

A small number of 2D and 3D coordinate systems and transformations are included.
We also have `IdentityTransformation` and `ComposedTransformation`, which allows us
to nest together arbitrary transformations to create a complex yet efficient
transformation chain.

### Coordinate types

The package accepts any `AbstractVector` type for Cartesian coordinates. For speed, we recommend
using a statically-sized container such as `SVector{N}` from *StaticArrays*.

We do provide a few specialist coordinate types. The `Polar(r, θ)` type is a 2D
polar representation of a point, and similarly in 3D we have defined
`Spherical(r, θ, ϕ)` and `Cylindrical(r, θ, z)`.

### Coordinate system transformations

Two-dimensional coordinates may be converted using these parameterless (singleton)
transformations:

1. [`PolarFromCartesian()`](@ref)
2. [`CartesianFromPolar()`](@ref)

Three-dimensional coordinates may be converted using these parameterless
transformations:

1. [`SphericalFromCartesian()`](@ref)
2. [`CartesianFromSpherical()`](@ref)
3. [`SphericalFromCylindrical()`](@ref)
4. [`CylindricalFromSpherical()`](@ref)
5. [`CartesianFromCylindrical()`](@ref)
6. [`CylindricalFromCartesian()`](@ref)

However, you may find it simpler to use the convenience constructors like
`Polar(SVector(1.0, 2.0))`.

### Translations

Translations can be be applied to Cartesian coordinates in arbitrary dimensions,
by e.g. `Translation(Δx, Δy)` or `Translation(Δx, Δy, Δz)` in 2D/3D, or by
`Translation(Δv)` in general (with `Δv` an `AbstractVector`). Compositions of
two `Translation`s will intelligently create a new `Translation` by adding the
translation vectors.

### Linear transformations

Linear transformations (a.k.a. linear maps), including rotations, can be
encapsulated in the `LinearMap` type, which is a simple wrapper of an
`AbstractMatrix`.

You are able to provide any matrix of your choosing, but your choice of type
will have a large effect on speed. For instance, if you know the dimensionality
of your points (e.g. 2D or 3D) you might consider a statically sized matrix
like `SMatrix` from *StaticArrays.jl*. We recommend performing 3D rotations
using those from *Rotations.jl* for their speed and flexibility. Scaling will
be efficient with Julia's built-in `UniformScaling`. Also note that compositions
of two `LinearMap`s will intelligently create a new `LinearMap` by multiplying
the transformation matrices.

### Affine maps

An Affine map encapsulates a more general set of transformation which are
defined by a composition of a translation and a linear transformation. An
`AffineMap` is constructed from an `AbstractVector` translation `v` and an
`AbstractMatrix` linear transformation `M`. It will perform the mapping
`x -> M*x + v`, but the order of addition and multiplication will be more obvious
(and controllable) if you construct it from a composition of a linear map
and a translation, e.g. `Translation(v) ∘ LinearMap(v)` (or any combination of
`LinearMap`, `Translation` and `AffineMap`).

`AffineMap`s can be constructed to fit point pairs `from_points => to_points`:

```jldoctest lsq; filter=[r"(2\.0|1\.9999\d+)" => "2.0", r"(0\.5|0\.49999\d+)" => "0.5", r"(0\.0|[ -]\d\.\d+e-\d\d)" => "0.0", r"(1\.0(?!0)|1\.0000\d+|0\.9999\d+)" => "1.0"]
julia> from_points = [[0, 0], [1, 0], [0, 1]];

julia> to_points   = [[1, 1], [3, 1], [1.5, 3]];

julia> AffineMap(from_points => to_points)
AffineMap([2.0 0.5; 0.0 2.0], [1.0, 1.0])
```

(You may get slightly different numerical values due to roundoff errors.) The points can be supplied as a collection of vectors or as a matrix with points as columns.

If you want to restrict the transformation to be rigid (rotation + translation)
or similar (rotation, translation, and scaling), use `kabsch` instead:

```jldoctest lsq; filter=[r"0\.9912\d+" => "0.9912", r"0\.1321\d+" => "0.1321", r"1\.4588\d+" => "1.4588", r"1\.3803\d+" => "1.3803"]
julia> rigid = kabsch(from_points => to_points)
AffineMap([0.9912279006826346 0.132163720091018; -0.1321637200910178 0.9912279006826348], [1.4588694597421157, 1.380311939802794])
```


### Perspective transformations

The perspective transformation maps real-space coordinates to those on a virtual
"screen" of one lesser dimension. For instance, this process is used to render
3D scenes to 2D images in computer generated graphics and games. It is an ideal
model of how a pinhole camera operates and is a good approximation of the modern
photography process.

The `PerspectiveMap()` command creates a `Transformation` to perform the
projective mapping. It can be applied individually, but is particularly
powerful when composed with an `AffineMap` containing the position and
orientation of the camera in your scene. For example, to transfer `points` in 3D
space to 2D `screen_points` giving their projected locations on a virtual camera
image, you might use the following code:

```julia
cam_transform = PerspectiveMap() ∘ inv(AffineMap(cam_rotation, cam_position))
screen_points = map(cam_transform, points)
```

There is also a `cameramap()` convenience function that can create a composed
transformation that includes the intrinsic scaling (e.g. focal length and pixel
size) and offset (defining which pixel is labeled `(0,0)`) of an imaging system.

## Acknowledgements

- The [Fugro Roames organization](https://github.com/FugroRoames)
